Luogu_2061_[USACO07OPEN]城市的地平线City Horizon

题目描述

Farmer John has taken his cows on a trip to the city! As the sun sets, the cows gaze at the city horizon and observe the beautiful silhouettes formed by the rectangular buildings.

The entire horizon is represented by a number line with N (1 ≤ N ≤ 40,000) buildings. Building i's silhouette has a base that spans locations Ai through Bi along the horizon (1 ≤ Ai < Bi ≤ 1,000,000,000) and has height Hi (1 ≤ Hi ≤ 1,000,000,000). Determine the area, in square units, of the aggregate silhouette formed by all N buildings.
约翰带着奶牛去都市观光。在落日的余晖里,他们看到了一幢接一幢的摩天高楼的轮廓在地平线 上形成美丽的图案。以地平线为 X 轴,每幢高楼的轮廓是一个位于地平线上的矩形,彼此间可能有 重叠的部分。奶牛一共看到了 N 幢高楼,第 i 幢楼的高度是 Hi,两条边界轮廓在地平线上的坐标是 Ai 到 Bi。请帮助奶牛们计算一下,所有摩天高楼的轮廓覆盖的总面积是多少。

输入输出格式

输入格式

第一行一个整数N,然后有N行,每行三个正整数ai、bi、Hi。

输出格式

一个数,数列中所有元素的和。

样例

INPUT

4
2 5 1
9 10 4
6 8 2
4 6 3

OUTPUT

16

HINT

N<=40000 , a、b、k<=10^9 。

SOLUTION

离散化+线段树

瞄一眼数据范围,不用想就知道一定要离散化,对于我来说这种离散化方法还是头一次用(就是这离散化调得我大头疼。)然后区间最大值?果断线段树啊。

其实对于题目给定的(a_i,b_i)画个图就可以看出来,由于我们线段树处理的是点,所以我们只要覆盖(a_i)(b_i-1)的点就行了。

而且因为对于每一段区间我们保留的是最大的(h),所以只要再修改以前,以(h)为关键字,再对每栋楼从小到大排个序就可以直接覆盖了。

如何计算呢?
因为我们离散化之后就剩下了一堆关键点(p),然后对于每一个(p_i)只要把(i)点的高度乘以((p_{i+1}-p_i))(前面有说,因为不包括右端点)就可以得到面积了。

然后记得push_down的时候一定要先判断(s[id])是否非零,不然就把原来存在的值清除了。

#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <algorithm>
using namespace std;
typedef long long LL;
const int N=40100;
int n,p[N<<1],s[N<<3];
LL ans=0;
struct BD{int a,b,h;}bld[N];
inline int read(){
	int x=0,f=1;char ch=getchar();
	while (ch<'0'||ch>'9') {if (ch=='-') f=-1;ch=getchar();}
	while (ch>='0'&&ch<='9') {x=x*10+ch-48;ch=getchar();}
	return x*f;}
bool cmp(BD x,BD y) {return x.h<y.h;}
void pushdown(int id,int l,int r){
	if (l==r) return;
	s[id<<1]=s[id];s[id<<1|1]=s[id];s[id]=0;}
void change(int id,int l,int r,int L,int R,int H){
	if (s[id]) pushdown(id,l,r);
	if (l>=L&&r<=R) {s[id]=H;return;}
	int mid=(l+r)>>1;
	if (mid>=L) change(id<<1,l,mid,L,R,H);
	if (mid<R) change(id<<1|1,mid+1,r,L,R,H);
}
int findh(int id,int l,int r,int ND){
	if (l==r) {return s[id];}
	if (s[id]) pushdown(id,l,r);
	int mid=(l+r)>>1;
	if (mid>=ND) return findh(id<<1,l,mid,ND);
	else return findh(id<<1|1,mid+1,r,ND);
}
int main(){
	int i,j;
	n=read();for (i=1;i<=n;++i) {
		bld[i].a=read();bld[i].b=read();bld[i].h=read();
		p[i*2-1]=bld[i].a;p[i*2]=bld[i].b;}
	sort(p+1,p+1+2*n);
	int cnt=2*n;//int cnt=unique(p+1,p+1+2*n)-p;
	sort(bld+1,bld+1+n,cmp);
	memset(s,0,sizeof(s));
	for (i=1;i<=n;++i){
		int L=lower_bound(p+1,p+1+cnt,bld[i].a)-p;
		int R=lower_bound(p+1,p+1+cnt,bld[i].b)-p;
	//	printf("L:%d R:%d H:%d
",L,R-1,bld[i].h);
		change(1,1,cnt,L,R-1,bld[i].h);
	}
	for (i=1;i<cnt;++i){
		LL H=findh(1,1,cnt,i);
		ans=ans+H*(p[i+1]-p[i]);
	//	printf("%lld %d;",H,(p[i+1]-p[i]));
	//	printf("%d %d
",p[i],p[i+1]);
	}
	printf("%lld
",ans);
	return 0;
}
原文地址:https://www.cnblogs.com/hkpls/p/9854939.html